/* ComicCreation Keyevents Extensions (DynAPI2) 
   Last modified: 2000.12.29
     by Henrik Vglin (hvaglin@yahoo.com)
         This Distribution is distributed under the terms of the GNU LGPL license.
 */

KeyEvent=function() {}

KeyEvent.prototype.getSource=function() {return this.src}

KeyEvent.prototype.setEvent=function(src,e) {

	this.src=src
        this.which=(is.ns4)?e.which:e.keyCode
//we don't want enter to be recognized whenever we press OK, cause then we may never get out of the loop
	if (this.which==13) { this.charKey = '[unknown]'; return false; }
	var curKey = String.fromCharCode(this.which).toLowerCase()

	var alt,ctrl,shft

	if (is.ie){
		alt=(e.altKey||e.altLeft||e.keyCode==18)?true:false 
		ctrl=(e.ctrlKey||e.ctrlLeft||e.keyCode==17)?true:false 
		shft=(e.shiftKey||e.shiftLeft||e.keyCode==16)?true:false
	}
	if (is.ns){
		var m=e.modifiers
		alt=(m==1||m==3||m==5||m==7)?true:false
		// alt=m & Event.ALT	
		ctrl=(m==2||m==3||m==6||m==7)?true:false	
		shft=(m==4||m==5||m==6||m==7)?true:false
       	}
	
	if (((curKey>='a')&&(curKey<='z'))||((curKey>='0')&&(curKey<='9'))) this.charKey = curKey;
	if (!((curKey>='a')&&(curKey<='z'))||((curKey>='0')&&(curKey<='9'))) {
		/* if (is.ns4) {
			switch (e.modifiers) { 
				case (m & Event.MASK_SHIFT): this.charKey = 'SHIFT'; break;
				case (m & Event.MASK_CTRL): this.charKey = 'CTRL'; break;
				case (m & Event.MASK_ALT): this.charKey = 'ALT'; break;
				default: this.charKey = '[unknown]';
				}
			} else { */
			switch (this.which) { 
				case 13: this.charKey = 'ENTER'; break;
				case 16: this.charKey = 'SHIFT'; break;
				case 17: this.charKey = 'CTRL'; break;
				case 18: this.charKey = 'ALT'; break;
				default: this.charKey = '[unknown]';
				}
		//	}
		} 

	this.ctrlKey=ctrl	//this doesn't work properly but on keypress
	this.altKey=alt  	//this doesn't work properly but on keypress
	this.orig=e
	return this
}

KeyEvent.prototype.getKey=function() {return this.charKey}

DynDocument.prototype.keys=new KeyEvent()
DynDocument.prototype.captureKeyEvents=function() {
	if (this.KeyEventsCaptured) return
	this.KeyEventsCaptured=true
	if (!this.eventListeners) this.eventListeners=[]
	this.hasEventListeners=true
	if (is.ns4) this.doc.captureEvents(Event.KEYPRESS | Event.KEYDOWN | Event.KEYUP | Event.ALT)
	this.doc.onkeypress=this.doc.onkeydown=this.doc.onkeyup=function(e) {
		if (is.ie) var e=this.lyrobj.elm.event
		var realsrc=is.ie?e.srcElement:e.target
		var src=realsrc.lyrobj
		if (!src) {
			src=DynAPI.getDocument(realsrc.elm)
			if (!src) return true
		}
		var evt=this.lyrobj.keys
		evt.setEvent(src,e)
        	src.invokeEvent(e.type,evt)
	}
}