<?
require "lib/class.FastTemplate.php3";
/*
print "parameter receive are : <br>";
print "MAP = $MAP<br>";
print "MAPNAME = $MAPNAME<br>";
print "INFO = $INFO<br>";
print "TTF_FONT = $TTF_FONT<br>";
print "TTF_SIZE = $TTF_SIZE<br>";
print "TITLECOLOR = $TITLECOLOR<br>";
print "INFOCOLOR = $INFOCOLOR<br>";
exit;
*/
//test if librairies gb and freefont are avilables
if (!(function_exists("ImageCopyResized")) ||!(function_exists("imagettftext")))
{
    print "libgd or FreeFont are not availables<br>";
    $tplerr=new FastTemplate("./template");
    $tplerr->define(array(main => "error.html"));
    $tplerr->parse(MAIN,"main");
    $tplerr->FastPrint(MAIN);  
    exit;
}
//---parameters---
$ext_type = ""; //type of map gif, jpg ou png
//MAP
if (!file_exists($DOCUMENT_ROOT.$MAP))
{
    print "$DOCUMENT_ROOT.$MAP does not exists<br>";
    $tplerr=new FastTemplate("./template");
    $tplerr->define(array(main => "error.html"));
    $tplerr->parse(MAIN,"main");
    $tplerr->FastPrint(MAIN);
    exit;
}
else
{
    preg_match("|.*\.(.*)$|",$MAP,$extension);
    if ((ImageTypes() & IMG_GIF) && ($extension[1] == "gif"))
        $ext_type = "GIF";
    if ((ImageTypes() & IMG_JPG) && ($extension[1] == "jpg") || ($extension == "jpeg"))
        $ext_type = "JPEG";
    if ((ImageTypes() & IMG_PNG) && ($extension[1] == "png"))
        $ext_type = "PNG";
    if (!$ext_type)
    {
       print "file type of the map is not supported, use only ";
       if ((ImageTypes() & IMG_GIF))
       {
          print "gif ";
       }
       if ((ImageTypes() & IMG_JPG))
       {
          print "jpg ";
       }
       if ((ImageTypes() & IMG_PNG))
       {
          print "png ";
       }
       print "<br>";
       $tplerr=new FastTemplate("./template");
       $tplerr->define(array(main => "error.html"));
       $tplerr->parse(MAIN,"main");
       $tplerr->FastPrint(MAIN);  
       exit;
    }
}
//TTF_FONT
if (!file_exists($DOCUMENT_ROOT.$TTF_FONT))
    $TTF_FONT = dirname($SCRIPT_NAME)."/lib/tahoma.ttf";
//TTF_SIZE
if (($TTF_SIZE > 100) || ($TTF_SIZE <5))
    $TTF_SIZE = 20;
//INFOCOLOR
$TITLECOLOR_R = 0;
$TITLECOLOR_G = 0;
$TITLECOLOR_B = 0;
if ($TITLECOLOR)
{
    if (strlen($TITLECOLOR) == 6)
    {
        $TITLECOLOR_R = hexdec(substr ($TITLECOLOR, 0 , 2));
        $TITLECOLOR_G = hexdec(substr ($TITLECOLOR, 2 , 2));
        $TITLECOLOR_B = hexdec(substr ($TITLECOLOR, 4 , 2));
    }
}
//INFOCOLOR
$INFOCOLOR_R = 0;
$INFOCOLOR_V = 0;
$INFOCOLOR_B = 0;
if ($INFOCOLOR)
{
    if (strlen($INFOCOLOR) == 6)
    {
        $INFOCOLOR_R = hexdec(substr ($INFOCOLOR, 0 , 2));
        $INFOCOLOR_V = hexdec(substr ($INFOCOLOR, 2 , 2));
        $INFOCOLOR_B = hexdec(substr ($INFOCOLOR, 4 , 2));
    }
}

//-----------------------------------------------------------------------------------------------------//
$L=600; //width of image to generate
$H=800; //height of image to generate
$T=50; //height of Title zone, top of the image
$I=300; //height of Info zone, bottom of the image
$width = abs($XMAP-$XDOWN); //width of the map in the result image
$height = abs($YMAP-$YDOWN); //height of the map in the result image
$widthOrig = abs($XMAP-$XDOWN); //width of the map in the original image
$heightOrig = abs($YMAP-$YDOWN); //height of the map in the original image
$V=0; //width on the left of the map (to center the map)
$ratio = $width / $height;
if ($ratio>=1) //$width > $height
{
	$width=$L;
	$height=$width/$ratio;
}
else
{
	$height=$H-$T-$I;
	$width=$height*$ratio;
    $V=($L-$width)/2;
}

$originalMap = "";
switch ($ext_type)
{
case "GIF":
    $originalMap = ImageCreateFromGIF($DOCUMENT_ROOT.$MAP);
    break;
case "JPEG":
    $originalMap = ImageCreateFromJPEG($DOCUMENT_ROOT.$MAP);
    break;
case "PNG":
    $originalMap = ImageCreateFromPNG($DOCUMENT_ROOT.$MAP);
    break;
}
$printMap = ImageCreate($L,$H);
ImageColorAllocate ($printMap, 255, 255, 255);

//insert of the map
ImageCopyResized ($printMap, $originalMap, $V, $T, $XMAP, $YMAP, $width, $height, $widthOrig, $heightOrig);
//insert of title
$color = ImageColorAllocate($printMap, $TITLECOLOR_R, $TITLECOLOR_G, $TITLECOLOR_B);
$box = imagettfbbox ($TTF_SIZE, 0, $DOCUMENT_ROOT.$TTF_FONT, $MAPNAME);
$INFOx = ceil(($L - ($box[2] - $box[0])) / 2);
$INFOy = ceil(($T - ($box[3] - $box[1])) /2);
imagettftext ($printMap, $TTF_SIZE, 0, $INFOx, $INFOy, $color, $DOCUMENT_ROOT.$TTF_FONT, $MAPNAME);

//insert of informations
$infox = 20;
$infoy = $T + $height + 40;
$color = ImageColorAllocate($printMap, $INFOCOLOR_R, $INFOCOLOR_V, $INFOCOLOR_B);
imagettftext ($printMap, $TTF_SIZE, 0, $infox, $infoy, $color, $DOCUMENT_ROOT.$TTF_FONT, $INFO);

if (ImageTypes() & IMG_JPG)
{
    Header("Content-type: image/jpeg");
    ImageJPEG($printMap);
}
else if (ImageTypes() & IMG_GIF)
{
    Header("Content-type: image/gif");
    ImageGIF($printMap);
}
else if (ImageTypes() & IMG_PNG)
{
    Header("Content-type: image/png");
    ImagePNG($printMap);
}
ImageDestroy($printMap);
?>
